﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=11
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub




Public Sub BlackAndWhite (Image As B4XBitmap, Threshold As Int) As B4XBitmap
	Private x, y, Mean, BWCol As Int
	Private col0, col1 As ARGBColor
	Private bmcImage, bmcResult As BitmapCreator
	
	bmcImage.Initialize(Image.Width, Image.Height)
	bmcImage.CopyPixelsFromBitmap(Image)
	bmcResult.Initialize(Image.Width, Image.Height)
	
	For y = 0 To Image.Height -1
		For x = 0 To Image.Width -1
			bmcImage.GetARGB(x, y, col0)
			col1.a = col0.a
			Mean = (col0.r + col0.g + col0.b) / 3
			If Mean >= Threshold Then
				BWCol = 255
			Else
				BWCol = 0
			End If
			col1.r = BWCol
			col1.g = BWCol
			col1.b = BWCol
			bmcResult.SetARGB(x, y, col1)
		Next
	Next
	Return bmcResult.Bitmap
End Sub
